﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient; //Sqlclient
using System.Web.SessionState; //Session

namespace QueryMssql_Web
{
    public partial class _Default : System.Web.UI.Page
    {
        public string Username;
        public string Password;
        public string ConnectionString;

        protected void btLogin_Click(object sender, EventArgs e)
        {
            Username = txtUser.Text;
            Password = txtPassword.Text;
            Session["User"] = txtUser.Text;
            Session["Password"] = txtPassword.Text;

            ConnectionString = "Data Source=.\\SQLEXPRESS;"; //local: .\\SQLEXPRESS ; remote: 10.0.0.100,1433
            ConnectionString += "User ID=" + Username + ";";
            ConnectionString += "Password=" + Password + ";";
            try
            {
                SqlDataSource sqlDataSource = new SqlDataSource();
                sqlDataSource.ConnectionString = ConnectionString;
                sqlDataSource.SelectCommand = "sp_helpdb"; //find all database name

                sqlDataSource.DataSourceMode = SqlDataSourceMode.DataReader;
                DataSourceSelectArguments args = new DataSourceSelectArguments();
                SqlDataReader dataReader = (SqlDataReader)sqlDataSource.Select(args);

                DropDownList_DB.Enabled = true;
                DropDownList_Table.Enabled = true;

                while (dataReader.Read())
                {
                    if (dataReader[0].ToString().Substring(0, 2) == "EZ")
                        DropDownList_DB.Items.Add(dataReader[0].ToString().Remove(0, 3));
                }
                dataReader.Close();
                sqlDataSource.Dispose();
                btLogin.Enabled = false;
                txtUser.Enabled = false;
                txtPassword.Enabled = false;
                btLogout.Enabled = true;           
            }
            catch (Exception ex)
            {
                string ErrorMessage = ex.Message;
                ErrorMessage = escape(ErrorMessage);
                string script = "alert('" + ErrorMessage + "');";
                ScriptManager.RegisterStartupScript(this, this.GetType(), "ALERT", script, true);
               
                return;
            }
        }
        
        protected string escape(string str) //avoid escape char
        {
            return str.Replace("'", " ");
        }
        protected void DropDownList_DB_SelectedIndexChanged1(object sender, EventArgs e)
        {
            Username = Session["User"].ToString();
            Password = Session["Password"].ToString();
            DropDownList_Table.Items.Clear();
            if (DropDownList_DB.SelectedIndex > 0)
            {
                DropDownList_Table.Items.Add("-Select Table-");
                string dataBase = "EZ_" + DropDownList_DB.SelectedItem.ToString();
                //find all table name
                string selectTableCmd = "select * from information_schema.Tables where TABLE_TYPE='BASE TABLE'"; 
                ConnectionString = "Data Source=.\\SQLEXPRESS;";
                ConnectionString += "User ID=" + Username + ";";
                ConnectionString += "Password=" + Password + ";";
                ConnectionString += "Database=" + dataBase + ";";

                SqlDataSource sqlDataSource = new SqlDataSource();
                sqlDataSource.ConnectionString = ConnectionString;
                sqlDataSource.SelectCommand = selectTableCmd;

                sqlDataSource.DataSourceMode = SqlDataSourceMode.DataReader;
                DataSourceSelectArguments args = new DataSourceSelectArguments();
                SqlDataReader dataReader = (SqlDataReader)sqlDataSource.Select(args);

                while (dataReader.Read())
                    DropDownList_Table.Items.Add(dataReader["TABLE_NAME"].ToString());
                
                dataReader.Close();
                sqlDataSource.Dispose();
            }
        }

        protected void DropDownList_Table_SelectedIndexChanged(object sender, EventArgs e)
        {
            Username = Session["User"].ToString();
            Password = Session["Password"].ToString();
            string Table = DropDownList_Table.SelectedItem.ToString();
            
            if (DropDownList_Table.SelectedIndex > 0)
            {
                btSearch.Enabled = true;
                string dataBase = "EZ_" + DropDownList_DB.SelectedItem.ToString();
                string selectMaxCmd = "select convert(char(25), Max(SamplingTime)) from "+Table; //last data
                string selectMinCmd = "select convert(char(25), Min(SamplingTime)) from "+Table; //first data

                ConnectionString = "Data Source=.\\SQLEXPRESS;";
                ConnectionString += "User ID=" + Username + ";";
                ConnectionString += "Password=" + Password + ";";
                ConnectionString += "Database=" + dataBase + ";";

                SqlDataSource sqlDataSource = new SqlDataSource();
                DataSourceSelectArguments args = new DataSourceSelectArguments();

                sqlDataSource.ConnectionString = ConnectionString;
                sqlDataSource.SelectCommand = selectMinCmd;
                sqlDataSource.DataSourceMode = SqlDataSourceMode.DataReader;
                SqlDataReader dataReader = (SqlDataReader)sqlDataSource.Select(args);
                while (dataReader.Read())
                {
                    if (dataReader[0].ToString().Length > 0)
                        addDate("Begin", dataReader[0].ToString());
                    else
                    {
                        txtBeginYear.Text = "";
                        txtBeginMon.Text = "";
                        txtBeginDate.Text = "";
                        txtBeginHr.Text = "";
                    }
                }
                dataReader.Close();
                sqlDataSource.Dispose();
             
                sqlDataSource.ConnectionString = ConnectionString;
                sqlDataSource.SelectCommand = selectMaxCmd;
                sqlDataSource.DataSourceMode = SqlDataSourceMode.DataReader;
                SqlDataReader dataReader1 = (SqlDataReader)sqlDataSource.Select(args);
                while (dataReader1.Read())
                {
                    if (dataReader1[0].ToString().Length > 0)
                        addDate("End", dataReader1[0].ToString());
                    else
                    {                
                        txtEndYear.Text = "";
                        txtEndMon.Text = "";
                        txtEndDate.Text = "";
                        txtEndHr.Text = "";
                    }
                }
                dataReader1.Close();              
                sqlDataSource.Dispose();
              
            }
        }
        private void addDate(string flag, string date)
        {
            if (flag == "Begin")
            {
                txtBeginMon.Text = date.Substring(0, 2);
                txtBeginDate.Text = date.Substring(3, 2);
                txtBeginYear.Text = date.Substring(6, 4);
                if (date.Substring(16, 1) == "P")
                {
                    if (date.Substring(11, 2) == "12")
                        txtBeginHr.Text = date.Substring(11, 2);
                    else
                        txtBeginHr.Text = Convert.ToString(Convert.ToInt16(date.Substring(11, 2)) + 12);
                }
                else
                    txtBeginHr.Text = date.Substring(11, 2);
            }
            else
            {
                txtEndMon.Text = date.Substring(0, 2);
                txtEndDate.Text = date.Substring(3, 2);
                txtEndYear.Text = date.Substring(6, 4);
                if (date.Substring(16, 1) == "P")
                {
                    if (date.Substring(11, 2) == "12")
                        txtEndHr.Text = date.Substring(11, 2);
                    else
                        txtEndHr.Text = Convert.ToString(Convert.ToInt16(date.Substring(11, 2)) + 12);
                }
                else
                    txtEndHr.Text = date.Substring(11, 2);
            }
        }

        protected void btSearch_Click(object sender, EventArgs e)
        {
            if (DropDownList_Table.SelectedItem.ToString() == "-Select Table-")
            {
                ScriptManager.RegisterStartupScript(this, this.GetType(), "ALERT", "alert('Please select the table!')", true);
                return;
            }
            Username = Session["User"].ToString();
            Password = Session["Password"].ToString();
            string beginTime = txtBeginYear.Text + "-" + txtBeginMon.Text + "-" + txtBeginDate.Text + " " + txtBeginHr.Text + ":00:00";
            string endTime = txtEndYear.Text + "-" + txtEndMon.Text + "-" + txtEndDate.Text + " " + txtEndHr.Text + ":00:00";

            string dataBase = "EZ_" + DropDownList_DB.SelectedItem.ToString();
            string selectCmd = "SELECT * FROM " + DropDownList_Table.SelectedItem.ToString() + " WHERE SamplingTime > '" + beginTime + "'and SamplingTime < '" + endTime + "'";
            
            ConnectionString = "Data Source=.\\SQLEXPRESS;";
            ConnectionString += "User ID=" + Username + ";";
            ConnectionString += "Password=" + Password + ";";
            ConnectionString += "Database=" + dataBase + ";";

            try
            {
                //1.Build SqlDataSource
                SqlDataSource SqlDataSource1 = new SqlDataSource();
                SqlDataSource1.ConnectionString = ConnectionString;

                //2.SQL command
                SqlDataSource1.SelectCommand = selectCmd;
                SqlDataSource1.DataSourceMode = SqlDataSourceMode.DataSet;

                //3.Execute SQL command
                DataSourceSelectArguments args = new DataSourceSelectArguments();

                DataView dv = (DataView)SqlDataSource1.Select(args);

                GridView1.DataSource = dv;
                GridView1.DataBind();

                SqlDataSource1.Dispose();
            }
            catch (Exception ex)
            { 
               ScriptManager.RegisterStartupScript(this, this.GetType(), "ALERT", "alert('Please Input the correct time')", true);
                return;
            }
        }

        protected void btLogout_Click(object sender, EventArgs e)
        {
            txtUser.Enabled = true;
            txtPassword.Enabled = true;
            DropDownList_DB.Items.Clear();
            DropDownList_DB.Items.Add("-Select Database-");
            DropDownList_DB.Enabled = false;
            DropDownList_Table.Items.Clear();
            DropDownList_Table.Items.Add("-Select Table-");
            DropDownList_Table.Enabled = false;
            btLogin.Enabled = true;
            btSearch.Enabled = false;
            btLogout.Enabled = false;

            GridView1.DataSource = null;
            GridView1.DataBind();

            txtBeginYear.Text = "";
            txtBeginMon.Text = "";
            txtBeginDate.Text = "";
            txtBeginHr.Text = "";
            txtEndYear.Text = "";
            txtEndMon.Text = "";
            txtEndDate.Text = "";
            txtEndHr.Text = "";
        }
    }
}
